<template>
  <div>
    <div class="dashboard__header">
      <h1 class="dashboard__title">آدرس های من</h1>
      <div class="dashboard__actions">
        <ResponsiveComponent>
          <Button type="outlined" color='dark' light size="sm" @click.native="$router.push('/dashboard/addresses/create')">
            <template #icon>
              <AddIcon />
            </template>
            آدرس جدید
          </Button>
          <template #collapsed>
            <Button type="text" round color='dark' light size="sm" @click.native="$router.push('/dashboard/addresses/create')">
              <template #icon>
                <AddIcon />
              </template>
            </Button>
          </template>
        </ResponsiveComponent>
        <Button type="text" color='dark' light round size="sm" @click.native="$router.push('/dashboard')">
          <template #icon>
            <BackIcon />
          </template>
        </Button>
      </div>
    </div>
    <div class="dashboard__body">
      <DashboardNavigation class="dashboard__nav" active="addresses" />
      <div class="dashboard__content">
        <div class="empty" v-if="!addresses.length > 0">
          <EmptyIcon class="empty__icon" />
          <p class="empty__text">آدرسی برای نمایش وجود ندارد!</p>
        </div>
        <div class="addresses" v-else>
          <AddressCard v-for="address in addresses" :key="address.id" :address="address" class="address" @delete="onDelete"/>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import AddressCard from "@/components/dashboard/AddressCard";
import Button from "@/components/base/Button";
import BackIcon from "@/assets/svgs/back.svg";
import AddIcon from "@/assets/svgs/add.svg";
import EmptyIcon from "@/assets/svgs/empty_box.svg";
import DashboardNavigation from "@/components/layout/DashboardNavigation";
import ResponsiveComponent from "@/components/base/ResponsiveComponent";

export default {
  components: {
    DashboardNavigation,
    AddressCard,
    Button,
    BackIcon,
    AddIcon,
    EmptyIcon,
    ResponsiveComponent
  },
  head() {
    return {
      title: "آدرس های من"
    }
  },
  layout: 'dashboard',
  async asyncData(context) {
    let addresses = [];
    const token = context.store.getters['auth/getToken'];
    await context.store.dispatch('addresses/fetchAddresses', token).then(response => {
      addresses = response.data.data;
    }).catch(error => {
      console.log(error);
    });
    return {
      addresses
    }
  },
  methods: {
    onDelete(id) {
      this.addresses = this.addresses.filter(cur => cur.id !== id);
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.dashboard__content
  position relative

.empty
  text-align center
  direction rtl
  color $grey
  margin-top $md
  &__icon
    width 10rem
    height 10rem
    fill $grey
    margin-bottom $xsm

.address
  &:not(:last-of-type)
    margin-bottom $md
</style>